from die import Die
from tqdm import tqdm
from collections import Counter

class FiveDice:
    def __init__(self):
        self.dice = [Die() for number in range(5)]

    def roll(self):
        for die in self.dice:
            die.roll()
        return self.faces()

    def faces(self):
        return [die.face for die in self.dice]

    def all_ones(self):
        for face in self.faces():
            if face != 1:
                return False
        return True
    
    def is_three_of_a_kind(self):
        count = Counter(self.faces())  
        for face_count in count.values():
            if face_count == 3: 
                return True
        return False
    
    def is_four_of_a_kind(self):
        count = Counter(self.faces())  
        for face_count in count.values():
            if face_count == 4: 
                return True
        return False

dice = FiveDice()
successes = 0
trials = 1000000
for trial in tqdm(range(trials)):
    dice.roll()
    if dice.all_ones():
        successes += 1

print(successes/trials)
#print(f"dice rolls: {dice.faces()}")
print(dice.faces())
print(dice.is_three_of_a_kind())
print(dice.is_four_of_a_kind())


